## overlay-boot 1.1

=== Makefile ===
ETCDIR = $(DESTDIR)/etc
INITDIR = $(DESTDIR)/etc/init.d
MAN8DIR = $(DESTDIR)/usr/share/man/man8
SBINDIR = $(DESTDIR)/usr/sbin
VARLIBDIR = $(DESTDIR)/var/lib/overlay-boot

MAN8FILES = overlay-boot.8 overlay-go.8 overlay-stop.8 overlay-diskfile.8
MAN8FILES += overlay-share.8
VARLIBFILES = overlay-boot overlay-go overlay-stop functions reaper
VARLIBFILES += overlay-init overlay-postmount overlay-premount
VARLIBFILES += overlay-diskfile
VARLIBFILES += overlay-share
INITFILES = subhosts
ETCFILES = subhosts.conf

# The default is to build asm/reaper
REAPER = src/reaper
all: $(REAPER)

# Specific rule: $(REAPER) is ensured by "recursive make"
$(REAPER): 
	$(MAKE) -C $$(dirname $(REAPER)) reaper

# Specific rule: the reaper program originates from $(REAPER)
reaper: $(REAPER)
	mv $< $@

# Specific rule: the sysvinit init file
$(INITDIR)/subhosts: subhosts.sh | $(INITDIR)/
	cp $< $@

# Specific rule: the sysvinit init configuration file
$(ETCDIR)/subhosts.conf: subhosts.conf | $(ETCDIR)/
	cp $< $@

# Generic rule: any dependee directory needs to be created
%/:
	mkdir -p $@

# Generic rule: a local .8 file depends on the same .8.adoc file, if any
$(MAN8FILES): %: %.adoc
	asciidoctor -b manpage $^

# Generic rule: an installed MAN8FILE file depends on a local the
# same, and that the installation directory exists
$(addprefix $(MAN8DIR)/,$(MAN8FILES)): $(MAN8DIR)/%: % | $(MAN8DIR)/
	cp $< $@

# Generic rule: an installed VARLIBFILES file depends on a local the
# same, and that the installation directory exists
$(addprefix $(VARLIBDIR)/,$(VARLIBFILES)): $(VARLIBDIR)/%: % | $(VARLIBDIR)/
	cp -p $< $@

# Make target: to clean up this workspace
clean:
	rm -f reaper *.8
	make -C $$(dirname $(REAPER)) clean

.INTERMEDIATE: reaper $(MAN8FILES)

# Make target: enumerates that which should be installed
INSTALLTARGETS += $(addprefix $(MAN8DIR)/,$(MAN8FILES))
INSTALLTARGETS += $(addprefix $(VARLIBDIR)/,$(VARLIBFILES))
INSTALLTARGETS += $(addprefix $(INITDIR)/,$(INITFILES))
INSTALLTARGETS += $(addprefix $(ETCDIR)/,$(ETCFILES))

install: $(INSTALLTARGETS)

# Make target: make a .deb file in ../
BUILDPACKAGE = -us -uc --build=full -Iolle
deb:
	dpkg-buildpackage $(BUILDPACKAGE)
#	PREFIX= INCLUDE_PREFIX=/usr

=== src/Makefile ===
all: reaper

# Pick compiler by preference
#CC = /usr/bin/gcc
CC = /usr/bin/musl-gcc

CFLAGS = -Wall -static -O3 -flto

reaper: reaper.c
	$(CC) $(CFLAGS) -o $@ $^

clean:
	rm -f reaper

=== debian/changelog ===
overlay-boot (1.1-1) experimental; urgency=medium

  * Added bind-mount of /etc/adjtime to keep subhost time aligned with host
  * Updated networking for ifupdown-without-bridge

 -- Ralph Ronnquist <rrq@rrq.au>  Mon, 29 Jan 2024 09:22:00 +1100

overlay-boot (1.0-1) unstable; urgency=medium

  * Version change for (first) unstable build.

 -- Ralph Ronnquist <rrq@rrq.au>  Mon, 04 Sep 2023 13:22:49 +1000

overlay-boot (0.1.14) experimental; urgency=medium

  * Bug fixes to handle bind mounted LIVE

 -- Ralph Ronnquist <rrq@rrq.au>  Mon, 04 Sep 2023 12:26:05 +1000

overlay-boot (0.1.13) experimental; urgency=medium

  * Revise network startup to handle the ifup case better.

 -- Ralph Ronnquist <rrq@rrq.au>  Fri, 25 Aug 2023 23:34:49 +1000

overlay-boot (0.1.12) experimental; urgency=medium

  * Change of email and signing key

 -- Ralph Ronnquist <rrq@rrq.au>  Mon, 26 Jun 2023 21:24:41 +1000

overlay-boot (0.1.11) experimental; urgency=medium

  * added vlan setup support

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sat, 27 May 2023 17:27:46 +1000

overlay-boot (0.1.10) experimental; urgency=medium

  * include the overlay-share utility

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Fri, 02 Dec 2022 19:21:58 +1100

overlay-boot (0.1.9) experimental; urgency=medium

  * discard most mounts before unshare

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sat, 12 Nov 2022 18:33:38 +1100

overlay-boot (0.1.8) unstable; urgency=medium

  * added configuration for shared subdirectories

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Thu, 29 Sep 2022 20:33:13 +1000

overlay-boot (0.1.7) unstable; urgency=medium

  * distribute /etc/subhosts.conf as well

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 10 May 2022 14:34:36 +1000

overlay-boot (0.1.6) unstable; urgency=medium

  * added sysvinit service support

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 10 May 2022 12:38:32 +1000

overlay-boot (0.1.5) unstable; urgency=medium

  * with optional cpuset accounting

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sat, 09 Apr 2022 10:12:58 +1000

overlay-boot (0.1.4) unstable; urgency=medium

  * added diskfile support

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 03 Apr 2022 22:02:56 +1000

overlay-boot (0.1.2) unstable; urgency=medium

  * bbonev squeeze of reaper.asm

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 29 Mar 2022 10:41:51 +1100

overlay-boot (0.1.1) unstable; urgency=medium

  * refactoring for more flexible config

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 27 Mar 2022 18:55:49 +1100

overlay-boot (0.1) unstable; urgency=medium

  * initial packaging

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Fri, 25 Mar 2022 18:05:01 +1100

=== debian/control ===
Source: overlay-boot
Section: misc
Priority: optional
Origin: Devuan
Maintainer: Ralph Ronnquist <rrq@grrq.au>
Build-Depends: debhelper-compat (= 13),
 asciidoctor, docbook-xml, libxslt1-dev, xsltproc, docbook-xsl,
 musl-tools
Standards-Version: 4.6.0
Homepage: https://borta.rrq.id.au/git?p=ralph/overlay-boot.git
Vcs-Git: https://borta.rrq.id.au/git?p=ralph/overlay-boot.git

Package: overlay-boot
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 coreutils (>=  8.32-4+b1), util-linux (>= 2.36.1-8+devuan2),
 mount, iproute2, ifupdown, dash, procps
Description: Admin scripts for running overlay subhosts
 Overlay subhosting uses unshare and chroot for running services
 within independent overlay filesystems, with a common kernel but
 independent namespaces. Aka "containerization with a modicum of bells
 and whistles".

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

#override_dh_clean:
#	dh_clean $@
#	dh_prep -Xtrial

## overlay-boot 1.2

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 ETCDIR = $(DESTDIR)/etc
 INITDIR = $(DESTDIR)/etc/init.d
+SRVDIR =  $(DESTDIR)/usr/lib/systemd/system
 MAN8DIR = $(DESTDIR)/usr/share/man/man8
 SBINDIR = $(DESTDIR)/usr/sbin
 VARLIBDIR = $(DESTDIR)/var/lib/overlay-boot
@@ -12,6 +13,7 @@
 VARLIBFILES += overlay-share
 INITFILES = subhosts
 ETCFILES = subhosts.conf
+SRVFILES = overlay-boot@.service
 
 # The default is to build asm/reaper
 REAPER = src/reaper
@@ -51,6 +53,10 @@
 $(addprefix $(VARLIBDIR)/,$(VARLIBFILES)): $(VARLIBDIR)/%: % | $(VARLIBDIR)/
 	cp -p $< $@
 
+# Generic rule: copy service files
+$(addprefix $(SRVDIR)/,$(SRVFILES)): $(SRVDIR)/%: % | $(SRVDIR)/
+	cp $< $@
+
 # Make target: to clean up this workspace
 clean:
 	rm -f reaper *.8
@@ -62,6 +68,7 @@
 INSTALLTARGETS += $(addprefix $(MAN8DIR)/,$(MAN8FILES))
 INSTALLTARGETS += $(addprefix $(VARLIBDIR)/,$(VARLIBFILES))
 INSTALLTARGETS += $(addprefix $(INITDIR)/,$(INITFILES))
+INSTALLTARGETS += $(addprefix $(SRVDIR)/,$(SRVFILES))
 INSTALLTARGETS += $(addprefix $(ETCDIR)/,$(ETCFILES))
 
 install: $(INSTALLTARGETS)

=== src/Makefile ===
all: reaper

CC = /usr/bin/gcc

CFLAGS = -Wall -static -O3 -flto

reaper: reaper.c
	$(CC) $(CFLAGS) -o $@ $^

clean:
	rm -f reaper

=== debian/changelog ===
overlay-boot (1.2-1) unstable; urgency=medium

  * First version into debian repository

 -- Ralph Ronnquist <rrq@rrq.au>  Tue, 03 Dec 2024 23:34:38 +1100

=== debian/control ===
Source: overlay-boot
Section: misc
Priority: optional
Maintainer: Ralph Ronnquist <rrq@rrq.au>
Build-Depends: debhelper-compat (= 13), asciidoctor
Standards-Version: 4.7.0
Homepage: https://git.devuan.org/devuan/overlay-boot.git
Vcs-Git: https://git.devuan.org/devuan/overlay-boot.git
vcs-browser: https://git.devuan.org/devuan/overlay-boot.git

Package: overlay-boot
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 mount, iproute2, ifupdown, procps
Description: Admin scripts for running overlay subhosts
 Overlay subhosting that uses unshare and chroot for running services
 within independent overlay filesystems, with a common kernel but
 independent namespaces. Aka "containerization with a modicum of bells
 and whistles".
 .
 This is a lightweight container alternative that supports the full
 range of use cases. It includes for example, "safe" trialling of
 software over an existing filesystem without "polluting" that
 filesystem (and without copying it). And, an overlay-boot setup might
 be made as a full foreign architecture sub-hosting. The framework is
 entirely in shell script form which is both fully transparent and
 easily modifiable.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# add prerm/postinst automagically
override_dh_installinit:
	dh_installinit -p overlay-boot  --name=subhosts --only-scripts
